/* PSS port addresses */

#define PSS_DATA      ((WORD)0x220)
#define PSS_STATUS    ((WORD)0x222)
#define PSS_CONTROL   ((WORD)0x222)
#define PSS_ID_VERS   ((WORD)0x224)

/* configuration addresses */

#define PSS_CONFIG    ((WORD)0x230)
#define WSS_CONFIG    ((WORD)0x232)
#define SB_CONFIG     ((WORD)0x234)
#define CD_CONFIG     ((WORD)0x236)
#define MIDI_CONFIG   ((WORD)0x238)
#define UART_CONFIG   ((WORD)0x23a)

/* PSS equates */

#define DMA0          (WORD)0x0001
#define DMA1          (WORD)0x0002
#define DMA3          (WORD)0x0003
#define DMA5          (WORD)0x0004
#define DMA6          (WORD)0x0005
#define DMA7          (WORD)0x0006

#define DMA_SPEC(num)	  (num + 1)

#define IRQ3          (WORD)0x0008
#define IRQ5          (WORD)0x0010
#define IRQ7          (WORD)0x0018
#define IRQ9          (WORD)0x0020
#define IRQ10         (WORD)0x0028
#define IRQ11         (WORD)0x0030
#define IRQ12         (WORD)0x0038

#define IRQ_SPEC(num)	  ((num < 9) ? ((num - 1) * 0x0004) : (num - 1) * 0x0004))

#define PSS_FLAG3     (WORD)0x0800
#define PSS_FLAG2     (WORD)0x0400
#define PSS_FLAG1     (WORD)0x1000
#define PSS_FLAG0     (WORD)0x0800

#define PSS_WRITE_EMPTY  (WORD)0x8000
#define PSS_READ_FULL    (WORD)0x4000

#if !defined(UINT)
#define UINT    unsigned int
#define WORD    unsigned short
#define UCHAR	unsigned char
#define ULONG	unsigned long
#define VOID    void
#define INT     int
#define CHAR    char
#define BOOL	INT
#endif

#define INLINE  __inline
#define DEBUG_OUTF  DebugOut
#define PCSZ	CHAR*
#define FILE	INT
#define BYTE	UCHAR


//VOID SetSw32HardwareGlobal (PSOUND_HARDWARE pHardware);
BOOL InitSw32 (BOOL bForceReset, PCSZ pszFile, WORD wWssBase, WORD wIrq, WORD wDma);

//	Parameters for Sound Blaster & MIDI emulation
extern ULONG uSoundBlasterModePort;
extern ULONG uActualSoundBlasterModePort;
extern ULONG uSoundBlasterIRQ;
extern ULONG uSoundBlasterDMA;
extern ULONG uMidiPort;
extern ULONG uMidiIRQ;
extern ULONG uCdInterfacePort;
extern ULONG uCdInterfaceIRQ;

#define SOUND_REG_SB_PORT		L"SoundBlasterModePort"
#define SOUND_REG_SB_IRQ 		L"SoundBlasterIRQ"
#define SOUND_REG_SB_DMA 		L"SoundBlasterDMA"
#define SOUND_REG_MIDI_PORT 	L"MidiPort"
#define SOUND_REG_MIDI_IRQ 		L"MidiIRQ"
#define SOUND_REG_CD_PORT 		L"CdInterfacePort"
#define SOUND_REG_CD_IRQ 		L"CdInterfaceIRQ"
