#if defined(DPF)
#undef DPF
#endif

#if DBG
#define DEBUG
#endif

#if defined(DEBUG)


    // service from Kernel-mode MONO monitor driver (also the MONOlithic driver sample)
    VOID MonoDbgPrint(IN ULONG  DbgPrintLevel, IN PUCHAR DbgMessage, IN ...); 

    #define DWORD ULONG

    #define DPF(text)                           \
        {                                       \
        dprintf1((text));                       \
        MonoDbgPrint(1, text);                  \
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(100);						\
        }

    #define DPF1(fmt, value)                    \
        {                                       \
        dprintf1((fmt, value));                 \
        MonoDbgPrint(1, fmt, value);            \
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(100);						\
        }

    #define DPF2(fmt, value1, value2)           \
        {                                       \
        dprintf1((fmt, value1, value2));        \
        MonoDbgPrint(1, fmt, value1, value2);   \
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(100);						\
        }
    
    #define DPF3(fmt, v1, v2, v3)           	\
        {                                       \
        dprintf1((fmt, v1, v2));        		\
        MonoDbgPrint(1, fmt, v1, v2, v3);   	\
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(100);						\
        }
    
    #define DPF5(fmt, v1, v2, v3, v4, v5)       \
        {                                       \
        dprintf1((fmt, v1, v2, v3, v4, v5));    \
        MonoDbgPrint(1, fmt, v1, v2, v3, v4, v5);\
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(100);						\
        }

#elif defined(DEBUGREL)


    // service from Kernel-mode MONO monitor driver (also the MONOlithic driver sample)
    VOID MonoDbgPrint(IN ULONG  DbgPrintLevel, IN PUCHAR DbgMessage, IN ...); 

    #define DWORD ULONG

    #define DPF(text)                           \
        {                                       \
        MonoDbgPrint(1, text);                  \
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(200);						\
        }

    #define DPF1(fmt, value)                    \
        {                                       \
        MonoDbgPrint(1, fmt, value);            \
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(200);						\
        }

    #define DPF2(fmt, value1, value2)           \
        {                                       \
        MonoDbgPrint(1, fmt, value1, value2);   \
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(200);						\
        }
    
    #define DPF3(fmt, v1, v2, v3)           	\
        {                                       \
        MonoDbgPrint(1, fmt, v1, v2, v3);   	\
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(200);						\
        }
    
    #define DPF5(fmt, v1, v2, v3, v4, v5)       \
        {                                       \
        MonoDbgPrint(1, fmt, v1, v2, v3, v4, v5);\
        MonoDbgPrint(1, "\n");                  \
		SoundDelay(200);						\
        }

#else

#if FALSE
    #define DPF(x)
    #define DPF1(text, value)
    #define DPF2(text, value1, value2)
    #define DPF3(fmt, v1, v2, v3)
    #define DPF5(fmt, v1, v2, v3, v4, v5)
    #define ASSERT(e)
#else

    #define DPF(x)								\
        {                                       \
		SoundDelay(200);						\
		}

    #define DPF1(text, value)					\
        {                                       \
		SoundDelay(200);						\
		}

    #define DPF2(text, value1, value2)			\
        {                                       \
		SoundDelay(200);						\
		}

    #define DPF3(fmt, v1, v2, v3)           	\
        {                                       \
		SoundDelay(200);						\
        }
    
    #define DPF5(fmt, v1, v2, v3, v4, v5)		\
        {                                       \
		SoundDelay(200);						\
		}
#endif

#endif
